"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const MutableContext_1 = __importDefault(require("./MutableContext"));
function createMutableContext(initialValue) {
    const context = new MutableContext_1.default(initialValue);
    const reactContext = react_1.createContext(context.getValue());
    const { Provider: ReactProvider } = reactContext;
    function MutableContextProvider(props) {
        const [value, setValue] = react_1.useState(() => context.getValue());
        react_1.useEffect(() => {
            const cb = () => {
                setValue(context.getValue());
            };
            context.subscribe(cb);
            return () => context.unsubscribe(cb);
        }, []);
        return react_1.default.createElement(ReactProvider, { value: value }, props.children);
    }
    function useMutableContext() {
        return react_1.useContext(reactContext);
    }
    return {
        Provider: MutableContextProvider,
        use: useMutableContext
    };
}
exports.createMutableContext = createMutableContext;
